#
# Conditional build:
%bcond_without	static_libs	# static library
#
Summary:	Foreign Function Interface library
Summary(pl.UTF-8):	Biblioteka Foreign Function Interface
Name:		libffi
Version:	3.4.8
Release:	1
Epoch:		7
License:	MIT-like
Group:		Libraries
#Source0Download: https://github.com/libffi/libffi/releases/
Source0:	https://github.com/libffi/libffi/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	ba5fc49d57d13b9e6cecd0c78d76688b
Patch0:		%{name}-info.patch
URL:		http://www.sourceware.org/libffi/
BuildRequires:	autoconf >= 2.71
BuildRequires:	automake
BuildRequires:	libltdl-devel >= 2:2
BuildRequires:	libtool >= 2:2
BuildRequires:	texinfo
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The libffi library provides a portable, high level programming
interface to various calling conventions. This allows a programmer to
call any function specified by a call interface description at
run-time.

Ffi stands for Foreign Function Interface. A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language. The
libffi library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface. A layer must
exist above libffi that handles type conversions for values passed
between the two languages.

%description -l pl.UTF-8
Biblioteka libffi dostarcza przenośny, wysokopoziomowy interfejs do
różnych konwencji wywołań funkcji. Pozwala to programiście wywołać
dowolną funkcję podaną przez opis interfejsu wywołania w czasie
działania programu.

FFI to skrót od Foreign Function Interface, czyli interfejsu do obcych
funkcji. Jest to potoczna nazwa interfejsu pozwalającego programowi
napisanemu w jednym języku wywoływać kod napisany w innym języku.
Biblioteka libffi daje tylko najniższą, zależną od maszyny warstwę
pełnego interfejsu. Potrzebne są wyższe warstwy do obsługi konwersji
typów dla wartości przekazywanych pomiędzy różnymi językami.

%package devel
Summary:	libffi development package
Summary(pl.UTF-8):	libffi - część dla programistów
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
Header files for libffi.

%description devel -l pl.UTF-8
Pliki nagłówkowe do biblioteki libffi.

%package static
Summary:	libffi static library
Summary(pl.UTF-8):	Statyczna biblioteka libffi
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static version of libffi.

%description static -l pl.UTF-8
Statyczna wersja biblioteki libffi.

%prep
%setup -q
%patch -P0 -p1

%build
%if 0
# as of 3.4.[78] build fails in strange way after ac/am/lt rebuild???
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%endif
%configure \
	--disable-multi-os-directory \
	%{!?with_static_libs:--disable-static}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post	devel -p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun	devel -p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%files
%defattr(644,root,root,755)
%doc ChangeLog* LICENSE README.md
%attr(755,root,root) %{_libdir}/libffi.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libffi.so.8

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libffi.so
%{_libdir}/libffi.la
%{_includedir}/ffi*.h
%{_pkgconfigdir}/libffi.pc
%{_mandir}/man3/ffi*.3*
%{_infodir}/libffi.info*

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libffi.a
%endif
%changelog
* Mon Apr 14 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libffi.git;a=log;h=master

* Mon Apr 14 2025 Jakub Bogusz <qboosh@pld-linux.org> 988aebb
- updated to 3.4.8

* Thu Feb 20 2025 Jakub Bogusz <qboosh@pld-linux.org> 5033fdc
- use patch -P

* Thu May 30 2024 Jakub Bogusz <qboosh@pld-linux.org> fe14f4f
- updated to 3.4.6

* Fri Feb 10 2023 Jakub Bogusz <qboosh@pld-linux.org> 70741d8
- updated to 3.4.4

* Sat Sep 03 2022 Jakub Bogusz <qboosh@pld-linux.org> 7de512b
- updated to 3.4.2 (new soname)

* Fri Mar 27 2020 Jan Rękorajski <baggins@pld-linux.org> 75e45e0
- drop libdir hackery in favor of just using a configure option

* Sun Feb 09 2020 Jakub Bogusz <qboosh@pld-linux.org> 99e66a4
- updated to 3.3 (note: new soname)
- updated info,libdir patches
- removed obsolete includedir patch

* Mon Sep 17 2018 Jan Palus <atler@pld-linux.org> 97a86a0
- upstream patch to fix include files location; rel 4

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 5bcbf13
- x32 rebuild
- release 3 (by relup.sh)

* Sat Jan 03 2015 Jan Rękorajski <baggins@pld-linux.org> 326fe4a
- updated BRs

* Tue Dec 09 2014 Jakub Bogusz <qboosh@pld-linux.org> 7863a1f
- added libdir patch (sanitize install dir stored in libffi.la on multilib archs)
- release 2

* Fri Nov 14 2014 Jakub Bogusz <qboosh@pld-linux.org> d210c9f
- updated to 3.2.1
- removed obsolete pc patch

* Sat Jul 26 2014 Jakub Bogusz <qboosh@pld-linux.org> 4310be1
- added pc patch (fixes libs path in libffi.pc); release 2

* Sun May 18 2014 Jakub Bogusz <qboosh@pld-linux.org> 33f1669
- updated to 3.1; could now replace libffi from gcc.spec

* Fri Mar 22 2013 Jakub Bogusz <qboosh@pld-linux.org> 3b38979
- up to 3.0.13

* Fri Feb 15 2013 Jakub Bogusz <qboosh@pld-linux.org> 5b1583c
- up to 3.0.12

* Fri Apr 13 2012 Jakub Bogusz <qboosh@pld-linux.org> 300fca2
- updated to 3.0.11 (note: new soname)

* Tue Oct 18 2011 lisu <lisu@pld-linux.org> 65e9775
- drop obsoleted rm

* Fri Sep 30 2011 Jakub Bogusz <qboosh@pld-linux.org> 7e04a4a
- fixed aclocal call

* Thu Sep 08 2011 Jakub Bogusz <qboosh@pld-linux.org> 8a23aa4
- updated to 3.0.10 (but gcc version is still used distro-wide though - so release 1.1 here)

